; GUI #
include win64a.inc
; --------------- 
WINDOWWIDTH  = 656
WINDOWHEIGHT = 518
BITMAPFILEHEADER STRUCT
  bfType        dw ?
  bfSize        dd ?
  bfReserved1   dw ?
  bfReserved2   dw ?
  bfOffBits     dd ?
BITMAPFILEHEADER ENDS
BITMAPINFOHEADER STRUCT
  biSize          dd ?
  biWidth         dd ?
  biHeight        dd ?
  biPlanes        dw ?
  biBitCount      dw ?
  biCompression   dd ?
  biSizeImage     dd ?
  biXPelsPerMeter dd ?
  biYPelsPerMeter dd ?
  biClrUsed       dd ?
  biClrImportant  dd ?
BITMAPINFOHEADER ENDS
TEXTURE_IMAGE struct
  sizeX		dd ?; Width Of Image In Pixels
  sizeY		dd ?; Height Of Image In Pixels
  data_		dd ?; Texture Data
TEXTURE_IMAGE ends
GL_ARRAY_BUFFER_ARB equ 8892h
GL_STATIC_DRAW_ARB  equ 88E4h
CVec struct
  x dd ?
  y dd ?
  z dd ?
CVec ends
CTexCoord struct
  u dd ?
  v0 dd ?
CTexCoord ends

.code
WinMain	proc
local	msg:MSG

	xor	ebx,ebx
        mov	edi,offset szClassName
        mov	esi,IMAGE_BASE
        mov	ecx,offset FileName
	invoke	LoadCursorFromFile
        push	rax	;hIconSm
	push	rdi	;lpszClassName
	push	rbx	;lpszMenuName
	push	COLOR_WINDOWTEXT+1;hbrBackground
	push	rax	;hCursor
	push	rax        ;hIcon
	push	rsi	;hInstance
	push	rbx        ;cbClsExtra & cbWndExtra
	pushaddr WndProc;lpfnWndProc
	mov	rax,(CS_HREDRAW or CS_VREDRAW or CS_OWNDC)shl 32 \
	or (sizeof WNDCLASSEX)
	push	rax	;cbSize & style
    	invoke	RegisterClassEx,esp	;addr WNDCLASSEX
	
	push	rbx
	push	rsi	;rsi = 400000h
	shl	esi,9	;rsi = CW_USEDEFAULT
	push	rbx
	push	rbx
	push	WINDOWHEIGHT
	push	WINDOWWIDTH
	push	rsi
	push	rsi
	sub	esp,20h
    	invoke	CreateWindowEx,0,edi,edi,WS_OVERLAPPEDWINDOW or \
	WS_CLIPCHILDREN or WS_CLIPSIBLINGS or WS_VISIBLE
; 
    	lea	edi,msg
@@:	invoke	GetMessage,edi,0,0,0	
	invoke	DispatchMessage,edi
	jmp	@b
WinMain endp
WndProc	proc	hWin:QWORD,uMsg:QWORD,wParam:QWORD,lParam:QWORD
local	ps:PAINTSTRUCT
local	w:dword
local	h:dword
local	szTitle[100h]:byte

        mov	hWin,rcx

        cmp	edx,WM_CREATE
	je      wmCREATE
        cmp	edx,WM_SIZE
	je      wmSIZE
        cmp	edx,WM_PAINT
	je      wmPAINT
	cmp	edx,WM_TIMER
	je	wmTIMER
        cmp	edx,WM_DESTROY
	je      wmDESTROY
        cmp	edx,WM_KEYDOWN
	je      wmKEYDOWN          
default:leave
	jmp	NtdllDefWindowProc_
wmDESTROY:invoke wglMakeCurrent,0,0
	invoke	wglDeleteContext,hRC
	invoke	ReleaseDC,hWin,hDC
        invoke	KillTimer,hWin,10
	invoke	RtlExitUserProcess,NULL
;------------------------------
wmTIMER:cvtsi2ss xmm0,milliseconds
	mulss	xmm0,const0_025
	addss	xmm0,g_flYRot
	movss	g_flYRot,xmm0
;	g_flYRot += (float)(milliseconds)/1000.0 * 25.0; Consistantly Rotate The Scenery
        invoke	InvalidateRect,,0,0
	jmp	wmBYE
wmKEYDOWN:mov	al,r8b;wParam
	cmp	al,VK_ESCAPE;user press 'Esc'?
	je	wmDESTROY

	invoke	InvalidateRect,,0,0
        jmp	wmBYE
;-----------------------------------------	
wmCREATE:invoke	GetDC ;  
	mov	hDC,rax
;    OpenGL ( OpenGL   
;)  
        mov	edx,offset PixFrm
	invoke	ChoosePixelFormat,eax
;  
	mov	r8d,offset PixFrm
	invoke	SetPixelFormat,hDC,eax
;     OpenGL
	invoke	wglCreateContext,hDC
	mov	hRC,rax
;   
	invoke	wglMakeCurrent,hDC,eax
	mov	r8d,milliseconds
	invoke	SetTimer,hWin,10,,0;  #10  25mSec
;-------------------------------------------------------
;  
	invoke	LoadHeightmap;   
; Check For VBOs Supported
	mov	ecx,offset aGl_arb_vertex_ ; "GL_ARB_vertex_buffer_object"
	invoke	IsExtensionSupported
	mov	g_fVBOSupported,al
	test	al,al;if( g_fVBOSupported )
	jz	@f
; Get Pointers To The GL Functions
;    GL
        mov	ecx,offset aGlgenbuffersar ; "glGenBuffersARB"
	invoke	wglGetProcAddress
	mov	glGenBuffersARB,rax;glGenBuffersARB = (PFNGLGENBUFFERSARBPROC) wglGetProcAddress("glGenBuffersARB")
	mov	ecx,offset aGlbindbufferar ; "glBindBufferARB"
	invoke	wglGetProcAddress
	mov	glBindBufferARB,rax;glBindBufferARB = (PFNGLBINDBUFFERARBPROC) wglGetProcAddress("glBindBufferARB")
	mov	ecx,offset aGlbufferdataar ; "glBufferDataARB"
	invoke	wglGetProcAddress
	mov	glBufferDataARB,rax;glBufferDataARB = (PFNGLBUFFERDATAARBPROC) wglGetProcAddress("glBufferDataARB");
	mov	ecx,offset aGldeletebuffer ; "glDeleteBuffersARB"
	invoke	wglGetProcAddress
	mov	glDeleteBuffersARB,rax;glDeleteBuffersARB = (PFNGLDELETEBUFFERSARBPROC) wglGetProcAddress("glDeleteBuffersARB");
; Load Vertex Data Into The Graphics Card Memory
	invoke	BuildVBOs; Build The VBOs
@@:; Setup GL States
	movss	xmm3,const1
	movss	xmm2,xmm3
	movss	xmm1,const0_5
	xorps	xmm0,xmm0
	invoke	glClearColor; Background
	movsd	xmm0,constd1
	invoke	glClearDepth;1.0f; Depth Buffer Setup
	invoke	glDepthFunc,GL_LEQUAL; The Type Of Depth Testing (Less Or Equal)
	invoke	glEnable,GL_DEPTH_TEST; Enable Depth Testing
	invoke	glShadeModel,GL_SMOOTH; Select Smooth Shading
	invoke	glHint,GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST; Set Perspective Calculations To Most Accurate
	invoke	glEnable,GL_TEXTURE_2D ; Enable Textures
	movss	xmm3,const1
	movss	xmm2,xmm3
	movss	xmm1,xmm3
	movss	xmm0,xmm3
	invoke	glColor4f;1, 1, 1, 1 ; Set The Color To White
        mov	r9d,(WINDOWHEIGHT shl 16)or WINDOWWIDTH 
wmSIZE:; --------------- Resize the scene
	movzx	r8,r9w
	mov	w,r8d
	shr	r9d,16
	mov	h,r9d
	invoke	glViewport,0,0;     
        invoke	glMatrixMode,GL_PROJECTION;     
	invoke	glLoadIdentity;		   
;    , ..    (  glcall ..     8 )
	movq	xmm3,constd1000
	movq	xmm2,constd1
	cvtsi2sd xmm1,w
	cvtsi2sd xmm0,h
	divsd	xmm1,xmm0
	movq	xmm0,constd45
	invoke	gluPerspective
;    
	invoke	glMatrixMode,GL_MODELVIEW;     ()
	invoke	glLoadIdentity		;   
        jmp	wmBYE
wmPAINT:; No pending messages: draw the scene
	lea	edx,ps
	invoke  BeginPaint
; --------------- Display the scene
	invoke	glClear,GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT; Clear Screen And Depth Buffer
	invoke	glLoadIdentity ; Reset The Modelview Matrix
	invoke	GetTickCount
	sub	eax,g_dwLastFPS
	cmp	eax,1000
	jb	@f; Get FPS
; When A Second Has Passed...
	invoke	GetTickCount
	mov	g_dwLastFPS,eax; = GetTickCount; Update Our Time Variable
	mov	eax,g_nFrames
	mov	g_nFPS,eax; Save The FPS
	and	g_nFrames,0; Reset The FPS Counter
	lea	edi,szTitle
	mov	ecx,256/8; Build The Title String
	xor	eax,eax
	rep	stosq
;   
	mov	eax,m_nVertexCount
	xor	edx,edx
	mov	ecx,3
	div	ecx
	mov	r8d,eax; m_nVertexCount/3
        lea	ecx,szTitle
	mov	edx,offset szClassName ; "Lesson 45: NeHe & Paul Frazee's VBO Tut - %d Triangles, %d FPS"
	mov	r9d, g_nFPS
	invoke	sprintf
	xor	eax,eax
	cmp	g_fVBOSupported,0;  Include A Notice About VBOs
	setz	al
	mov	edx,string0[rax*4]
	lea	ecx,szTitle
	invoke	strcat
	lea	edx,szTitle
	invoke	SetWindowText,hWin  ; Set The Title
@@:	inc	g_nFrames; Increment Our FPS Counter
	
; Move The Camera
	xorps	xmm2,xmm2
	movss	xmm1,const_220
	xorps	xmm0,xmm0
	invoke	glTranslatef; Move Above The Terrain
	xorps	xmm3,xmm3
	xorps	xmm2,xmm2
	movss	xmm1,const1
	movss	xmm0,const10
	invoke	glRotatef; Look Down Slightly
	xorps	xmm3,xmm3
	movss	xmm2,const1
	xorps	xmm1,xmm1
	movss	xmm0,g_flYRot
	invoke	glRotatef; Rotate The Camera

; Enable Pointers
	invoke	glEnableClientState,GL_VERTEX_ARRAY ; Enable Vertex Arrays
	invoke	glEnableClientState,GL_TEXTURE_COORD_ARRAY ; Enable Texture Coord Arrays
; Set Pointers To Our Data
	cmp	g_fVBOSupported,0;if( g_fVBOSupported )
	jz	@f
	mov	edx, m_nVBOVertices
	invoke	glBindBufferARB,GL_ARRAY_BUFFER_ARB ;
	invoke	glVertexPointer,3, GL_FLOAT, 0, 0 ; Set The Vertex Pointer To The Vertex Buffer
	mov	edx, m_nVBOTexCoords
	invoke	glBindBufferARB,GL_ARRAY_BUFFER_ARB ;
	xor	r9d,r9d; Set The TexCoord Pointer To The TexCoord Buffer
	jmp	@2
@@:	mov	r9d,m_pVertices
	invoke	glVertexPointer,3, GL_FLOAT, 0 ; // Set The Vertex Pointer To Our Vertex Data
	mov	r9d,m_pTexCoords
@2:	invoke	glTexCoordPointer,2, GL_FLOAT, 0 ; // Set The Vertex Pointer To Our TexCoord Data
; Render
	mov	r8d,m_nVertexCount
	invoke	glDrawArrays,GL_TRIANGLES, 0 ; Draw All Of The Triangles At Once
; Disable Pointers
	invoke	glDisableClientState,GL_VERTEX_ARRAY ; Disable Vertex Arrays
	invoke	glDisableClientState,GL_TEXTURE_COORD_ARRAY ; Disable Texture Coord Arrays
;   
	invoke	SwapBuffers,hDC
        lea	edx,ps
	invoke  EndPaint,hWin
wmBYE:	leave
	retn	
WndProc	endp
IsExtensionSupported proc szTargetExtension:dword
local	old_edi:dword
local	old_esi:dword

	mov	szTargetExtension,ecx
	mov	old_esi,esi
	mov	old_edi,edi
	cmp	byte ptr [rcx], 0
	jz	exitFALSE
	mov	edx,20h		; int
	invoke	strchr
	or	eax, eax
	jnz	exitFALSE
; Get Extensions String
	invoke	glGetString,GL_EXTENSIONS
	mov	esi, eax
	mov	edx,szTargetExtension		; char *
	invoke	strstr,eax
	mov	edx, eax
	or	eax, eax
	jz	bye
@2:	mov	edi,szTargetExtension
	or	ecx,-1
	xor	eax, eax
	repne	scasb
	not	ecx
	dec	ecx
	add	ecx, edx
	cmp	edx, esi
	jz	@f
	cmp	byte ptr [rdx-1], 20h
	jnz	@1
@@:	mov	al, [rcx]
	cmp	al, 20h
	jz	exitTRUE
	or	al, al
	jz	exitTRUE
@1:	mov	edx,szTargetExtension		; char *
	mov	esi, ecx
	invoke	strstr
	mov	edx, eax
	or	eax, eax
	jnz	@2	
exitFALSE:xor	al, al
	jmp	bye
; ---------------------------------------------------------------------------
exitTRUE:mov	al,TRUE
bye:	mov	esi,old_esi
	mov	edi,old_edi
	leave
	ret
IsExtensionSupported endp

LoadHeightmap proc
local	nX:dword
local	nZ:dword
local	nTri:dword
local	nIndex:dword;  
local	flX:dword
local	flZ:dword
local	buff:dword
local	buff1[256]:byte
local	szReadWrite:QWORD	;number of bytes actually read or write
local	hFile:dword
local	FSize:dword

	mov	ecx,offset aTerrain
	invoke	CreateFile,,GENERIC_READ,0,0,OPEN_EXISTING,\
        FILE_ATTRIBUTE_ARCHIVE,rbx
	mov	hFile,eax
        invoke	GetFileSize,eax,0
        mov	FSize,eax
	inc	eax				; Append a 0 char
	invoke	GlobalAlloc,GMEM_ZEROINIT or GMEM_FIXED,eax
	mov	buff,eax
	mov	[rsp+20h],rbx
	lea	r9d,szReadWrite
        invoke	ReadFile,hFile,eax,FSize   
        invoke	CloseHandle,hFile
; Load Texture Data
	mov	esi,buff
        mov	eax,[rsi + BITMAPINFOHEADER.biWidth + sizeof BITMAPFILEHEADER]
	mov	m_pTextureImage.sizeX,eax
        movzx	eax,word ptr [rsi + BITMAPINFOHEADER.biHeight + sizeof BITMAPFILEHEADER]
	mov	m_pTextureImage.sizeY,eax
        mov	esi,buff
        add	esi,[rsi + BITMAPFILEHEADER.bfOffBits]
	mov	m_pTextureImage.data_,esi
; Bitmap Load & Generate Vertex Field
	imul	edx,m_pTextureImage.sizeY,6
	imul	edx,m_pTextureImage.sizeX
	shr	edx,4;sizeX*sizeY*6/16 (flResolution*flResolution=4*4=16)
        mov	m_nVertexCount,edx
        imul	edx,(sizeof CVec)
	invoke	GlobalAlloc,GMEM_ZEROINIT or GMEM_FIXED
	mov	m_pVertices,eax;m_pVertices = new CVec[m_nVertexCount];	;    
	imul	edx,m_nVertexCount,(sizeof CTexCoord)
	invoke	GlobalAlloc,GMEM_ZEROINIT or GMEM_FIXED
	mov	m_pTexCoords,eax

	and	nIndex,0;  
	and	nZ,0
@3:     and	nX,0
@2:     and	nTri,0
@1:	cvtsi2ss xmm0,nX
	cmp	nTri,1
	jz	@f
	cmp	nTri,2
	jz	@f
	cmp	nTri,5
	jnz	@4
@@:	addss	xmm0,flResolution
@4:	movss	flX,xmm0
	cvtsi2ss xmm0,nZ
	cmp	nTri,2
	jz	@f
	cmp	nTri,4
	jz	@f
	cmp	nTri,5
	jnz	@5
@@:	addss	xmm0,flResolution
@5:	movss	flZ,xmm0
;  ,  PtHeight   Y 
	cvtss2si ecx,flX
	cvtss2si edx,xmm0;flZ
	invoke	PtHeight
	imul	eax,nIndex,(sizeof CVec)
	mov	edx,m_pVertices
	movss	[rax+rdx].CVec.y,xmm0
        mov	ecx,m_pTextureImage.sizeY
	shr	ecx,1
	cvtsi2ss xmm1,ecx
	movss	xmm0,flZ
	subss	xmm0,xmm1;flZ-(m_pTextureImage->sizeY/2)
	movss	[rax+rdx].CVec.z,xmm0
        mov	ecx,m_pTextureImage.sizeX
	shr	ecx,1
	cvtsi2ss xmm1,ecx
	movss	xmm0,flX
	subss	xmm0,xmm1;flX-(m_pTextureImage->sizeX/2)
	movss	[rax+rdx].CVec.x,xmm0

        imul	eax,nIndex,(sizeof CTexCoord)
        mov	edx,m_pTexCoords

	cvtsi2ss xmm1,m_pTextureImage.sizeX
	movss	xmm0,flX
	divss	xmm0,xmm1	
        movss	[rax+rdx].CTexCoord.u,xmm0;m_pTexCoords[nIndex].u = flX/m_pTextureImage->sizeX
	cvtsi2ss xmm1,m_pTextureImage.sizeY
	movss	xmm0,flZ
	divss	xmm0,xmm1
        movss	[rax+rdx].CTexCoord.v0,xmm0;m_pTexCoords[nIndex].v = flZ/m_pTextureImage->sizeY
        inc	nIndex
        inc	nTri
	cmp	nTri,6
	jb	@1
	add	nX,4
	mov	eax,m_pTextureImage.sizeX
	cmp	nX,eax
	jb	@2
	add	nZ,4
	mov	eax,m_pTextureImage.sizeY
	cmp	nZ,eax
	jb	@3

;    OpenGL
	mov	edx,offset m_nTextureId
	invoke	glGenTextures,1 ; Get An Open ID
	mov	edx,m_nTextureId
	invoke	glBindTexture,GL_TEXTURE_2D;, m_nTextureId; Bind The Texture
	xor	edx,edx
	mov	r9d,m_pTextureImage.sizeX
	mov	eax,m_pTextureImage.sizeY
	mov	[rsp+20h],rax
	mov	[rsp+28h],rdx
	mov	qword ptr [rsp+30h],GL_RGB
	mov	qword ptr [rsp+38h],GL_UNSIGNED_BYTE
	mov	eax,m_pTextureImage.data_
	mov	[rsp+40h],rax
	invoke	glTexImage2D,GL_TEXTURE_2D,,3
	invoke	glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR
	invoke	glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR
;   
	mov	ecx,buff
	invoke	GlobalFree; Free The Texture Data
	leave
	retn
LoadHeightmap endp
PtHeight proc nX:dword, nY:dword

	mov	nX,ecx
	mov	nY,edx
; Calculate The Position In The Texture, Careful Not To Overflow
	mov	eax,nY
	xor	edx,edx
	div	m_pTextureImage.sizeY
	imul	edx,m_pTextureImage.sizeX
	mov	ecx,edx

	mov	eax,nX
	xor	edx,edx
	div	m_pTextureImage.sizeX
	add	ecx,edx;ecx=(nX % m_pTextureImage->sizeX)+((nY % m_pTextureImage->sizeY)*m_pTextureImage->sizeX))
        imul	ecx,3
        mov	eax,m_pTextureImage.data_
	add	eax,ecx;m_pTextureImage->data[nPos]
	xor	edx,edx
	mov	dl,[rax+2];flB = m_pTextureImage->data[nPos + 2]; Get The Blue Component
	cvtsi2ss xmm0,edx
	mulss	xmm0,const0_114
	mov	dl,[rax+1];flG = m_pTextureImage->data[nPos + 1]; Get The Green Component
	cvtsi2ss xmm1,edx
	mulss	xmm1,const0_587
	addss	xmm0,xmm1
	mov	dl,[rax];flR = m_pTextureImage->data[nPos]; Get The Red Component
	cvtsi2ss xmm1,edx
	mulss	xmm1,const0_299
	addss	xmm0,xmm1
;	return (0.299*flR + 0.587*flG + 0.114*flB  Calculate The Height Using The Luminance Algorithm
	leave
	ret
PtHeight endp
BuildVBOs proc dummy:dword
; Generate And Bind The Vertex Buffer
	mov	edx,offset m_nVBOVertices
	invoke  glGenBuffersARB,1; Get A Valid Name
	mov	edx,m_nVBOVertices
	invoke  glBindBufferARB,GL_ARRAY_BUFFER_ARB; Bind The Buffer
; Load The Data
	imul	edx,m_nVertexCount,12;3*(sizeof float)
	mov	r8d,m_pVertices
	invoke  glBufferDataARB,GL_ARRAY_BUFFER_ARB,,,GL_STATIC_DRAW_ARB
; Generate And Bind The Texture Coordinate Buffer
	mov	edx,offset m_nVBOTexCoords
	invoke  glGenBuffersARB,1 ; Get A Valid Name
	mov	edx,m_nVBOTexCoords
	invoke  glBindBufferARB,GL_ARRAY_BUFFER_ARB; Bind The Buffer
; Load The Data
	imul	edx,m_nVertexCount,8;2*(sizeof float)
	mov	r8d,m_pTexCoords
	invoke  glBufferDataARB,GL_ARRAY_BUFFER_ARB,,,GL_STATIC_DRAW_ARB
; Our Copy Of The Data Is No Longer Necessary, It Is Safe In The Graphics Card
	mov	ecx,m_pVertices
	invoke	GlobalFree
	and	m_pVertices,0
	mov	ecx,m_pTexCoords
	invoke	GlobalFree
	and	m_pTexCoords,0
	leave
	ret
BuildVBOs endp
;---------------------------------------------------------------------------
hDC	dq	?
hRC	dq	?
PixFrm	label	PIXELFORMATDESCRIPTOR 
	nSize             dw	sizeof PIXELFORMATDESCRIPTOR
  	nVersion          dw	1
  	dwFlags           dd	PFD_SUPPORT_OPENGL or PFD_DOUBLEBUFFER or PFD_DRAW_TO_WINDOW
  	iPixelType        db	PFD_TYPE_RGBA
  	cColorBits        db	32;Select Our Color Depth
  	cRedBits          db	0
  	cRedShift         db	0
  	cGreenBits        db	0
  	cGreenShift       db	0
  	cBlueBits         db	0
  	cBlueShift        db	0;Color Bits Ignored
  	cAlphaBits        db	0;No Alpha Buffer
  	cAlphaShift       db	0;Shift Bit Ignored
  	cAccumBits        db	0;No Accumulation Buffer
  	cAccumRedBits     db	0
  	cAccumGreenBits   db	0
  	cAccumBlueBits    db	0
  	cAccumAlphaBits   db	0;Accumulation Bits Ignored
  	cDepthBits        db	16;16Bit Z-Buffer (Depth Buffer)
  	cStencilBits      db	0;No Stencil Buffer
  	cAuxBuffers       db	0;No Auxiliary Buffer
  	iLayerType        db	PFD_MAIN_PLANE;Main Drawing Layer
  	bReserved         db	0;Reserved
  	dwLayerMask       dd	0
  	dwVisibleMask     dd	0
  	dwDamageMask      dd	0;Layer Masks Ignored

szClassName	db "NeHe lesson#45: VBO Tutorial - %d Triangles, %d FPS, ",0
FileName	db "br_Rabbit3.cur",0
aTerrain	db "terrain.bmp",0
aGl_arb_vertex_ db "GL_ARB_vertex_buffer_object",0
aGlgenbuffersar db "glGenBuffersARB",0
aGlbindbufferar db "glBindBufferARB",0
glDeleteBuffersARB dq ?
glBufferDataARB dq ?
glGenBuffersARB dq ?
aGlbufferdataar db "glBufferDataARB",0
glBindBufferARB dq ?
aGldeletebuffer db "glDeleteBuffersARB",0
milliseconds	dd 25
m_nVertexCount  dd 0; Vertex Count
m_pVertices     dd 0; Vertex Data
m_pTexCoords    dd 0; Texture Coordinates
m_nTextureId    dd 0; Texture ID
m_nVBOVertices  dd 0; Vertex VBO Name
m_nVBOTexCoords dd 0; Texture Coordinate VBO Name
m_pTextureImage TEXTURE_IMAGE <>; Heightmap Data
g_flYRot	dd 0; Rotation
string0		dd offset string1,offset string2
string1		db "Using VBOs",0
string2		db "Not Using VBOs",0
g_dwLastFPS	dd 0;   FPS
g_nFrames	dd 0; FPS   FPS
g_nFPS          dd 0
g_fVBOSupported db FALSE
flResolution	dd 4.0
;-----------------------------
;float
const0_025	dd 0.025
const0_114	dd 0.114
const0_299	dd 0.299
const0_5	dd 0.5
const0_587	dd 0.587
const1		dd 1.0
const10		dd 10.0
const_220	dd -220.0
;double
constd1		dq 1.0
constd45	dq 45.0
constd1000	dq 1000.0
end